unit Launcher;

interface

uses Windows, SysUtils, Classes, Process, Forms;

procedure StartStarCraft(Process: TProcess; Map: String);

implementation

uses Plugins;

type
  TMappedData = array [0..$1000-1] of Byte;

procedure StartStarCraft(Process: TProcess; Map: String);
var
  FileMapping: THandle;
  MappedData: ^TMappedData;
  MapString: RawByteString;
  i: Integer;
begin
  FileMapping := CreateFileMapping(INVALID_HANDLE_VALUE, nil, PAGE_EXECUTE_READWRITE, 0, $10000, 'StarCraft II IPC Mem');
  if FileMapping = 0 then
    RaiseLastOSError;

  MappedData := MapViewOfFile(FileMapping, FILE_MAP_ALL_ACCESS, 0, 0, $10000);
  if MappedData = nil then
    RaiseLastOSError;

  FillChar(MappedData^, $10000, 0);

  MappedData[32] := 4; // IPC State

  PCardinal(@MappedData[40])^ := GetCurrentProcessId();

  MappedData[72] := 2; // 1 = Regular Launch, 2 = Load Map, 3 = Load Replay

  PInteger(@MappedData[76])^ := -1; // StarCraft II Version. -1 == Auto

  MapString := RawByteString(UTF8String(Map));

  Move(PAnsiChar(MapString)^, MappedData[92], Length(MapString));

  for i := 0 to PluginList.Count - 1 do
    if PluginList[i].Enabled then
      if @PluginList[i].SliLoad <> nil then
        PluginList[i].SliLoad(Process, nil, PluginList[i].Data);

  Process.Resume;

  while MappedData[32] <> 5 do
    begin
      if WaitForSingleObject(Process.Handle, 0) = WAIT_OBJECT_0 then
        Break;
      Sleep(64);
    end;

  MappedData[36] := 0;

  if not UnmapViewOfFile(MappedData) then
    RaiseLastOSError;

  CloseHandle(FileMapping);
end;

end.
